----------------------------------
--      Module Declaration      --
----------------------------------

local boss = BB["General Bjarngrim"]
local mod = BigWigs:New(boss, tonumber(("$Revision: 550 $"):sub(12, -3)))
if not mod then return end
mod.partycontent = true
mod.otherMenu = "The Storm Peaks"
mod.zonename = BZ["Halls of Lightning"]
mod.enabletrigger = boss
mod.guid = 28586
mod.toggleoptions = {"mortalStrike", "mortalStrikeBar", -1, "berserker", "bosskill"}

--------------------------------
--        Localization        --
--------------------------------

local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

L:RegisterTranslations("enUS", function() return {
	berserker = "Berserker Aura",
	berserker_applied = "Gained Berserker Aura",
	berserker_desc = "Warn when General Bjarngrim gains and loses Berserker Aura.",
	berserker_removed = "Berserker Aura Fades",
	cmd = "Bjarngrim",
	mortalStrike = "Mortal Strike",
	mortalStrikeBar = "Mortal Strike Bar",
	mortalStrikeBar_desc = "Show a bar for the duration of the Mortal Strike debuff.",
	mortalStrike_desc = "Warn when some has Mortal Strike debuff.",
	mortalStrike_message = "Mortal Strike: %s",
}

end )

L:RegisterTranslations("deDE", function() return {
	berserker = "Berserkeraura",
	berserker_applied = "Berserkeraura erhalten",
	berserker_desc = "Warnen wenn General Bjarngrim seine Berserkeraura erhält bzw. verliert.",
	berserker_removed = "Berserkeraura verblasst",
	cmd = "Bjarngrim",
	mortalStrike = "Tödlicher Stoß",
	mortalStrikeBar = "Tödlicher Stoß-Anzeige",
	mortalStrikeBar_desc = "Eine Leiste für die verbleibende Dauer des Debuffs von Tödlicher Stoß anzeigen.",
	mortalStrike_desc = "Warnen wenn jemand von Tödlicher Stoß betroffen ist.",
	mortalStrike_message = "Tödlicher Stoß: %s",
}

end )

L:RegisterTranslations("esES", function() return {
}

end )

L:RegisterTranslations("esMX", function() return {
}

end )

L:RegisterTranslations("frFR", function() return {
	berserker = "Aura de berserker",
	berserker_applied = "Aura de berserker gagnée",
	berserker_desc = "Prévient quand le Général Bjarngrim gagne et perd son Aura de berserker.",
	berserker_removed = "Aura de berserker disparue",
	cmd = "Bjarngrim",
	mortalStrike = "Frappe mortelle",
	mortalStrikeBar = "Frappe mortelle - Barre",
	mortalStrikeBar_desc = "Affiche une barre indiquant la durée de la Frappe mortelle.",
	mortalStrike_desc = "Prévient quand un joueur subit les effets de la Frappe mortelle.",
	mortalStrike_message = "Frappe mortelle : %s",
}

end )

L:RegisterTranslations("koKR", function() return {
	berserker = "광폭 오라",
	berserker_applied = "광폭 오라 획득",
	berserker_desc = "장군 뱌른그림의 광폭 오라 획득과 사라짐을 알립니다.",
	berserker_removed = "광폭 오라 사라짐",
	cmd = "뱌른그림",
	mortalStrike = "죽음의 일격",
	mortalStrikeBar = "죽음의 일격 바",
	mortalStrikeBar_desc = "죽음의 일격 디버프가 지속되는 바를 표시합니다.",
	mortalStrike_desc = "죽음의 일격 디버프가 걸린 플레이어를 알립니다.",
	mortalStrike_message = "죽음의 일격: %s",
}

end )

L:RegisterTranslations("ruRU", function() return {
	berserker = "Аура берсерка",
	berserker_applied = "Применена Аура берсерка",
	berserker_desc = "Предупреждать, когда Генерал Бьярнгрин получает или теряет Ауру берсерка.",
	berserker_removed = "Аура берсерка рассеялась",
	cmd = "Бьярнгрин",
	mortalStrike = "Смертельный удар",
	mortalStrikeBar = "Полоса смертельного удара",
	mortalStrikeBar_desc = "Отображение полосы продолжительности дебаффа от смертельного удара.",
	mortalStrike_desc = "Предупреждать, когда кто-нибудь получает дебафф от смертельного удара.",
	mortalStrike_message = "Смертельный удар: %s",
}

end )

L:RegisterTranslations("zhCN", function() return {
	berserker = "狂暴光环",
	berserker_applied = "获得 狂暴光环！",
	berserker_desc = "当比亚格里将军获得狂暴光环或消退时发出警报。",
	berserker_removed = "狂暴光环 消退！",
	mortalStrike = "致死打击",
	mortalStrikeBar = "致死打击计时条",
	mortalStrikeBar_desc = "当致死打击减益持续时显示计时条。",
	mortalStrike_desc = "当玩家中了致死打击减益时发出警报。",
	mortalStrike_message = "致死打击：>%s<！",
}

end )

L:RegisterTranslations("zhTW", function() return {
	berserker = "狂暴者光環",
	berserker_applied = "獲得 狂暴者光環！",
	berserker_desc = "當畢亞格林將軍獲得狂暴者光環或消退時發出警報。",
	berserker_removed = "狂暴者光環 消退！",
	cmd = "畢亞格林",
	mortalStrike = "致死打擊",
	mortalStrikeBar = "致死打擊計時條",
	mortalStrikeBar_desc = "當致死打擊減益持續時顯示計時條。",
	mortalStrike_desc = "當玩家中了致死打擊減益時發出警報。",
	mortalStrike_message = "致死打擊：>%s<！",
}

end )

----------------------------------
--        Initialization        --
----------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_AURA_APPLIED", "MortalStrike", 16856)
	self:AddCombatListener("SPELL_AURA_APPLIED", "Berserker", 41107)
	self:AddCombatListener("SPELL_AURA_REMOVED", "BerserkerRemoved", 41107)
	self:AddCombatListener("UNIT_DIED", "BossDeath")
end

----------------------------------
--        Event Handlers        --
----------------------------------

function mod:MortalStrike(player, spellId)
	if self.db.profile.mortalStrike then
		self:IfMessage(L["mortalStrike_message"]:format(player), "Important", spellId)
	end
	if self.db.profile.mortalStrikeBar then
		self:Bar(L["mortalStrike_message"]:format(player), 5, spellId)
	end
end

function mod:Berserker(target, spellId)
	if self.db.profile.beserker and (target == boss) then
		self:IfMessage(L["berserker_applied"]:format(player), "Urgent", spellId)
	end
end

function mod:BerserkerRemoved(player, spellId)
	if self.db.profile.beserker and (target == boss) then
		self:IfMessage(L["berserker_removed"], "Attention", spellId)
	end
end
